/* Sorting using N-squared algorithms */
Parse Arg N
If N="" then Do
   Say "How many numbers to sort?"
   Parse Pull N
end /* do */

/* Generate some random numbers */
Do i=1 to N
   x.i=Random(0,N)
   x2.i=x.i
end /* do */
x.0=N
/* Call the bubble sort routine */
elapsed=BubbleSort()
Say "Bubble sort took" elapsed "seconds."
Call ResetItems

/* Call the straight insertion sort routine */
elapsed=InsertionSort()
Say "Insertion sort took" elapsed "seconds."
Call ResetItems

/* Call the modified insertion sort routine */
elapsed=ModifiedInsertionSort()
Say "Modified insertion sort took" elapsed "seconds."
Exit

BubbleSort:
Procedure Expose x.
start=Time("R")
do i = x.0 to 1 by -1 until sorted = 1
  sorted = 1
  do j = 2 to i
    m = j - 1
    if x.m > x.j then
    do
      a=x.m
      x.m=x.j
      x.j=x
      sorted=0
    end /* do */
  end /* do */
end /* do */
end=time("R")
elapsed=end-start
Return elapsed

InsertionSort:
Procedure Expose x.
start=Time("R")
Do i=1 to x.0-1
   Do j=i+1 to x.0
      If x.j<x.i then  Do
         a=x.i
         x.i=x.j
         x.j=a
      end /* do */
   end /* do */
end /* do */
end=time("R")
elapsed=end-start

Return elapsed

ModifiedInsertionSort:
start=Time("R")
Do i=1 to x.0
   m=x.i
   k=i
   do j=i+1 to x.0
      if x.j<m then do 
         m=x.j
         k=j
      end
   end /* do */
   a=x.i
   x.i=m
   x.k=a
end /* do */
end=time("R")
elapsed=end-start
Return elapsed

ResetItems: /* Resets the sorted items to their scrambled state */
Procedure Expose x. x2. 
do i=1 to x.0
   x.i=x2.i
end /* do */

Return
